--- old/usr/src/pkg/manifests/system-header.mf	Thu Apr  2 12:08:36 2020
+++ new/usr/src/pkg/manifests/system-header.mf	Thu Apr  2 12:08:36 2020
@@ -386,7 +386,9 @@
 file path=usr/include/hal/libhal-storage.h
 file path=usr/include/hal/libhal.h
 $(i386_ONLY)file path=usr/include/ia32/sys/asm_linkage.h
+$(i386_ONLY)file path=usr/include/ia32/sys/kdi_regs.h
 $(i386_ONLY)file path=usr/include/ia32/sys/machtypes.h
+$(i386_ONLY)file path=usr/include/ia32/sys/privmregs.h
 $(i386_ONLY)file path=usr/include/ia32/sys/privregs.h
 $(i386_ONLY)file path=usr/include/ia32/sys/psw.h
 $(i386_ONLY)file path=usr/include/ia32/sys/pte.h
--- old/usr/src/uts/intel/ia32/sys/Makefile	Thu Apr  2 12:08:36 2020
+++ new/usr/src/uts/intel/ia32/sys/Makefile	Thu Apr  2 12:08:36 2020
@@ -19,10 +19,12 @@
 # CDDL HEADER END
 #
 #
+#pragma ident	"%Z%%M%	%I%	%E% SMI"
+#
 # Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# Copyright 2020 Joyent, Inc.
+# uts/intel/ia32/sys/Makefile
 #
 # include global definitions
 include ../../../../Makefile.master
@@ -29,7 +31,9 @@
 
 HDRS=  \
 	asm_linkage.h	\
+	kdi_regs.h	\
 	machtypes.h	\
+	privmregs.h	\
 	privregs.h	\
 	psw.h		\
 	pte.h		\
--- /dev/null	Thu Apr  2 12:08:36 2020
+++ new/usr/src/uts/intel/ia32/sys/kdi_regs.h	Thu Apr  2 12:08:36 2020
@@ -0,0 +1,73 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ *
+ * Copyright 2018 Joyent, Inc.
+ */
+
+#ifndef _IA32_SYS_KDI_REGS_H
+#define	_IA32_SYS_KDI_REGS_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#define	KDIREG_NGREG	21
+
+/*
+ * %ss appears in a different place than a typical struct regs, since the
+ * machine won't save %ss on a trap entry from the same privilege level.
+ */
+
+#define	KDIREG_SAVFP	0
+#define	KDIREG_SAVPC	1
+#define	KDIREG_SS	2
+#define	KDIREG_GS	3
+#define	KDIREG_FS	4
+#define	KDIREG_ES	5
+#define	KDIREG_DS	6
+#define	KDIREG_EDI	7
+#define	KDIREG_ESI	8
+#define	KDIREG_EBP	9
+#define	KDIREG_ESP	10
+#define	KDIREG_EBX	11
+#define	KDIREG_EDX	12
+#define	KDIREG_ECX	13
+#define	KDIREG_EAX	14
+#define	KDIREG_TRAPNO	15
+#define	KDIREG_ERR	16
+#define	KDIREG_EIP	17
+#define	KDIREG_CS	18
+#define	KDIREG_EFLAGS	19
+#define	KDIREG_UESP	20
+
+#define	KDIREG_PC	KDIREG_EIP
+#define	KDIREG_SP	KDIREG_ESP
+#define	KDIREG_FP	KDIREG_EBP
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* _IA32_SYS_KDI_REGS_H */
--- /dev/null	Thu Apr  2 12:08:36 2020
+++ new/usr/src/uts/intel/ia32/sys/privmregs.h	Thu Apr  2 12:08:36 2020
@@ -0,0 +1,67 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+#ifndef	_IA32_SYS_PRIVMREGS_H
+#define	_IA32_SYS_PRIVMREGS_H
+
+#pragma ident	"%Z%%M%	%I%	%E% SMI"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#if !defined(__i386)
+#error	"non-i386 code depends on i386 privileged header!"
+#endif
+
+#ifndef _ASM
+
+#define	PM_GREGS (1 << 0)
+#define	PM_CRREGS (1 << 1)
+#define	PM_DRREGS (1 << 2)
+
+/*
+ * This structure is intended to represent a complete machine state for a CPU,
+ * when that information is available.  It is only for use internally between
+ * KMDB and the kernel, or within MDB.  Note that this isn't yet finished.
+ */
+typedef struct privmregs {
+	ulong_t pm_flags;
+	/* general registers */
+	struct regs pm_gregs;
+	/* cr0-8 */
+	ulong_t pm_cr[8];
+	/* dr0-8 */
+	ulong_t pm_dr[8];
+} privmregs_t;
+
+#endif /* !_ASM */
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif	/* !_IA32_SYS_PRIVMREGS_H */
